import React from 'react';
import { render } from 'react-dom';
import GraphiQL from '@tyk-technologies/graphiql';

const TykGraphiqlExplorer = ({ url, schema }) => {

  const fetcher = async (graphQLParams, opts={headers:{}}) => {
    const data = await fetch(url, {
      method: 'POST',
      headers: {
        Accept: 'application/json',
        'Content-Type': 'application/json',
        ...opts.headers,
      },
      body: JSON.stringify(graphQLParams),
    });
    return data.json().catch(() => data.text());
  };

  return (
    <GraphiQL
      fetcher={fetcher}
      ideName={'TYK'}
      schema={schema}
      headerEditorEnabled
      shouldPersistHeaders
    />
  );
};

class GraphiqlInit {
  constructor(config) {
    const { containerId, url, schema } = config;
    render(
      <TykGraphiqlExplorer url={url} schema={schema} />,
      document.getElementById(containerId)
    );
  }
}

window.GraphiqlInit = GraphiqlInit;
