#!/bin/bash
set -e 

ADMIN_KEY="12345"
IN_FILE="policies.json"
DASHBOARD_HOST_PORT="localhost:3000"

ADD_POL="admin/policies/import"

for i in "$@"
do
case $i in
	-k=*|--key=*)
    ADMIN_KEY="${i#*=}"
    shift # past argument=value
    ;;
    -h=*|--host=*)
    DASHBOARD_HOST_PORT="${i#*=}"
    shift # past argument=value
    ;;
    -f=*|--file=*)
    IN_FILE="${i#*=}"
    shift # past argument=value
    ;;
    *)
            # unknown option
    ;;
esac
done

if [ -z "$ADMIN_KEY" ]; then
    echo "Missing admin key (-k=12345)"
    exit
fi

if [ -z "$IN_FILE" ]; then
    echo "Missing input file (-f=./data/file.json)"
    exit
fi

if [ -z "$DASHBOARD_HOST_PORT" ]; then
    echo "Missing hostname and port (-h=localhost:3000)"
    exit
fi

ORG_ID=$(jq -r '.id' $IN_FILE)
CREATE=$(curl --silent --header "admin-auth: $ADMIN_KEY" -X POST --data @$IN_FILE http://$DASHBOARD_HOST_PORT/$ADD_POL 2>&1)
echo $CREATE